import os
import zipfile
import requests

my_url = "https://vip.123pan.cn/1820333155/extensions_website/"

def download_zip(url, save_folder):
    # 检查是否存在 brc_GUI.exe 文件
    if (save_folder / "brc_GUI.exe").exists():
        print("brc_GUI.exe 已存在，跳过下载。")
        return

    url = my_url + url
    basename = os.path.basename(url)
    save_path = save_folder / basename

    if not save_folder.exists():
        save_folder.mkdir(parents=True)

    with requests.get(url, stream=True) as r:
        r.raise_for_status()
        with open(save_path, 'wb') as f:
            for chunk in r.iter_content(chunk_size=16384):
                f.write(chunk)

    with zipfile.ZipFile(save_path, 'r') as zip_ref:
        for member in zip_ref.namelist():
            try:
                # 目标路径
                target_path = save_folder / member
                
                # 如果文件存在且不被占用，则删除
                if target_path.exists():
                    try:
                        os.remove(target_path)
                    except PermissionError:
                        print(f"文件正在使用，跳过: {target_path}")
                        continue
                
                # 解压文件
                zip_ref.extract(member, save_folder)
            except Exception as e:
                print(f"解压文件时出错: {e}")

    # 删除 ZIP 文件
    if save_path.exists():
        os.remove(save_path)